lorom
;--------------Dialogue in SM, by Tundain----------------
;This patch let's you add dialogue to Sm, allowing samus or other characters to speak
;alternatively, you can also use it to simply make text appear on the HUD, if you want to explain something to the player (like an item ability)
;there can be up to two characters talking at once, samus and a differet character.
;an icon is displayed to show which one is talking
; you can edit the Samus.bin file with a GFX editor to change the look of samus's icon.
;You can also add your own icons (explanation at the bottom) for multiple different-looking characters.
;the text is customizable, see info below on how to setup the text and what you can do with it

;in order to trigger the dialogue, a plm is used, see below on how to use it.
;Lastly, you will have to add dialogue entries into an array, see below as well for info.

;Things to note:
;-whilst the dialogue is active, the game keeps running, except samus cannot move
;this means that enemies and/or other things can still interact with / damage samus, so be carefull.
;-the icon of the other character uses the palette of the first enemy in the enemy GFX list (the palette of enemy with palette line 1)

;--FREESPACE---
;repoint to respective banks
!Bank80Freespace = $80CD90
!Bank84Freespace = $84EFE0;use this address as your PLM

;repoint to any bank
!BankAny1Freespace = $83AE00;gfx storage
!BankAny2Freespace  = $8AEA00;code storage
;---------------------------

;user defines------------
!TextSFX = #$45 ; sound effect to play when writing the text
!DefaultTimer = #$0004 ;default speed when writing the text
!DefaultTimersmall = #$04

;code defines--------
!Pal0 = $00
!Pal1 = $04
!Pal2 = $08
!Pal3 = $0C
!Pal4 = $10
!Pal5 = $14
!Pal6 = $18
!Pal7 = $1C

!DialogueFlag = $1E79
!Wait = $90
!SwitchTo = $91
!SetPal = $92
!NextLine = $93
!Finish = $94

!Samus = $00
!Other = $02

;------Used RAM
;this patch uses all of this unused RAM
!TextIndex = $1886
!MapIndex = $1888
!Timer = $188A
!SpeakerIndex = $188C
!Palettebits = $188D
!Pointer = $188E

;check to make sure no other patches you may have applies are using this RAM as well, and if so change the defines above to a different address of unused RAM
;in order to find unused RAM addresses, go to https://patrickjohnston.org/ASM/Lists/Super%20Metroid/RAM%20map.asm and search for addresses where it says "unused"

org $809B4E;hijack
JSR checkifdialogue

;--------BANK $80--------------------
;--------Hud tilemap handler hijack--
org !Bank80Freespace
checkifdialogue:
LDA !DialogueFlag : BIT #$0001 : BNE +
LDA $09C0 : RTS
+
JSL HandleDialogue
PLA : JMP $9CAA

;-------------ANY BANK 2---------------------------------------
;------------Dialogue handling code & dialogue entries---------
org !BankAny2Freespace
HandleDialogue:
PHB : PHK : PLB
DEC !Timer : BNE ignore
LDA !Pointer : STA $12;load pointer to start of text entry
LDY !TextIndex : LDX !MapIndex;load current position in text/hud tilemap
LDA #$0000
SEP #$20
LDA ($12),y : STA $00 : AND #$F0 : CMP #$90 : BEQ operation; if within $90-$9F, perform operation instead

LDA $00 : STA $7EC608,x;write text
INX : LDA !Palettebits : STA $7EC608,x : DEX ;write palette
LDA !TextSFX  : JSL $8090C1;play sound
adjust:
INX #2 : STX !MapIndex
default:
REP #$20
LDA !DefaultTimer : STA !Timer
exit:
INY : STY !TextIndex
ignore:
LDA !DialogueFlag : BIT #$0002 : BNE +;if no dialogue, don't draw icon
LDA !SpeakerIndex : AND #$00FF : TAX
LDA Xoffsets,x : STA $14 : LDA #$0028 : STA $12 : LDY speakers,x : LDA palettes,x : STA $16 : JSL $81879F ; draw icon
+
PLB : RTL

operation:
LDA $00 : AND #$0F : ASL : TAX : JMP (operations,x)

operations:
DW delay,Switchto,Palette,Nextline,Finish

delay:;sets a specified delay before continuing to write text
LDX !MapIndex
INY : LDA ($12),y : STA !Timer
REP #$20
BRA exit

Switchto:;switches to the argument character to speak
LDX !MapIndex
LDA #$0F
- STA $7EC608,x : DEX #2 : BPL -
INY : LDA ($12),y : STA !SpeakerIndex
BRA adjust

Palette:;sets the argument palette for the text
LDX !MapIndex
INY : LDA ($12),y : STA !Palettebits
BRA default

Nextline:;advances to the next line on the hud
REP #$20
LDA !MapIndex : CMP #$0040 : BPL +
LDA #$003E : TAX : JMP adjust
+
LDA #$007E : TAX : JMP adjust


Finish:; disables dialogue mode
REP #$20
LDA !DialogueFlag : AND #$8000 : STA !DialogueFlag : DEC $05F7
LDX $0330
LDA #$0040 : STA $D0,x
LDA.w #$988B : STA $D2,x
LDA.w #$8098 : STA $D3,x
LDA #$5800 : STA $D5,x
TXA : CLC : ADC #$0007 : STA $0330
JSL $809A79
PLB : RTL

speakers:
DW samus,other
palettes:
DW $0800,$0200
Xoffsets:
DW $0010,$00F0

samus:;spritemaps for the two icons
DW $0004
DB $F8,$01,$F8,$D0,$30
DB $00,$00,$F8,$D1,$30
DB $F8,$01,$00,$D2,$30
DB $00,$00,$00,$D3,$30

other:
DW $0004
DB $F8,$01,$F8,$D4,$30
DB $00,$00,$F8,$D5,$30
DB $F8,$01,$00,$D6,$30
DB $00,$00,$00,$D7,$30

Activate:
PHB : PHK : PLB
INC !DialogueFlag : INC $05F7
JSR GetPointer : LDA $0000,y : STA !Pointer;load pointer to dialogue data
LDA #$080F : LDX #$00C6
- STA $7EC608,x : DEX #2 : BPL -;clear full hud
LDA #$0000 : SEP #$20
LDA $0002,y : JSL $8081FA;set dialogue event bit
LDA !DefaultTimersmall : STA !Timer ; set initial timer value
LDA #$28 : STA !Palettebits;load initial palette bits
LDA $0003,y : BPL ++
LDA #$03 : STA !DialogueFlag
++
AND #$0F : STA !SpeakerIndex
REP #$20
LDX $0330
LDA $0003,y : BPL ++
LDA #$0080 : STA $D0,x : LDA.w #Samus : STA $D2,x : LDA.w #Samus>>8 : STA $D3,x : LDA #$6D00 : STA $D5,x : TXA : CLC : ADC #$0007 : TAX;load samus icon GFX
LDA #$0080 : STA $D0,x : LDA.w $0004,y : STA $D2,x : LDA.w $0005,y : STA $D3,x : LDA #$6D40 : STA $D5,x : TXA : CLC : ADC #$0007 : TAX;load other speaker icon GFX
++
LDA #$000C : STA $D0,x : LDA.w #$988B : STA $D2,x : LDA.w #$8098 : STA $D3,x : LDA #$581A : STA $D5,x : TXA : CLC : ADC #$0007 : STA $0330;clear minimap top part

+
PLB : RTL

GetPointer: ; stores the pointer to the dialogue data in [A] and [Y]
LDA $1DC7,x : AND #$00FF : ASL : TAY : LDA DialoguesArray,y : TAY
RTS

check:;checks if dialogue event bit was set, if so, deletes the plm
PHB : PHY : PHK : PLB
JSR GetPointer : LDA $0005,y : AND #$00FF : JSL $808233 : BCC +
STZ $1C37,x
+
PLY : PLB : RTL
;--------------------------------------------------------------
;--------------Dialogue definitions storage--------------------

DialoguesArray:; this is the array that you wanna expand with every dialogue that you add
DW Dialogue_0,Dialogue_1,Dialogue_2

;Dialogue entry format

; TTTT EE SS [GFX]

;TTTT = Text pointer, this is the label you place at each text entry
;EE = event, the event to set to indicate this dialogue has ended
;SS = settings

;8X = don't draw any icons (if you want dialogue that explains an item for example)
;X0 = samus is the one that starts speaking
;X2 = the other character is the one that starts speaking

;OPTIONAL
;[GFX] = graphics pointer to the gfx of the other character that is speaking (the label with the data at BANK ANY 1)
;only used when the settings want icons being drawn, so don't place it if there are none

Dialogue_0:
DW Dialogue_0_Text : DB $15,$80

Dialogue_1:
DW Dialogue_1_Text : DB $16,$00 : DL Pirate

Dialogue_2:
DW Dialogue_2_Text : DB $17,$02 : DL Pirate


;------Text information-------------
;write the text in the same way as below. 

;there are 5 commands you can use during the text
;-!Wait sets a delay for the specified number of frames (that is right next to it)
   ;P.S this is in Hexadecimal

;-!SwitchTo switches the character talking, it resets all the text, and switches to the character specified
   ; !Samus, switches to samus (duh)
   ; !Other switches to the other character
   ; P.S: you can switch to the same person that was already talking, if you have one character that is speaking a lot
   
;-!SetPal changes the palette of the text to the one specified

;-!NextLine skips to the next line

;-!Finish is the terminator, this end the dialogue
table text.tbl
Dialogue_0_Text:
DB "PRESS DOWN TWICE TO ENTER MORPH BALL FORM"
DB !Wait,$1E
DB !SwitchTo,!Samus
DB "WHILST IN MORPH BALL FORM, SAMUSCAN ENTER NARROW PASSAGEWAYS"
DB !Wait,$1E
DB !Finish

Dialogue_1_Text:
DB "KRAID, SHOW YOURSELF"
DB !Wait,$1E
DB " I KNOW" 
DB !NextLine
DB "YOU'RE HERE"
DB !Wait,$24
DB !SwitchTo,!Other
DB "I SEE YOU'VE MADE IT HERE SAMUS,"
DB !Wait,$20
DB "NOW,"
DB !SetPal,!Pal7
DB "PREPARE TO DIE!"
DB !Wait,$18
DB !Finish

Dialogue_2_Text:
DB "SAMUS, WAIT!"
DB !Wait,$20
DB !SwitchTo,!Samus
DB "WHAT DO YOU WANT!"
DB !Wait,$20
DB !SwitchTo,!Other
DB "I WANT TO TELL YOU SOMETHING"
DB !NextLine
DB !Wait,$20
DB "YOU CAN USE THE "
DB !SetPal,!Pal7
DB "POWERBOMBS "
DB !SetPal,!Pal2
DB "TO   BLOW UP THE "
DB !SetPal,!Pal7
DB "TUBE "
DB !SetPal,!Pal2
DB !Wait,$20
DB !SwitchTo,!Samus
DB "WHY DO YOU HELP ME?"
DB !Wait,$20
DB !SwitchTo,!Other
DB "I HAVE MY REASONS."
DB !Wait,$3C
DB !Finish

;-----------------------BANK $84--------------------------------
;-----------------------Trigger PLM code------------------------

;the PLM that triggers the dialogue

;PLM settings

; TT II

;TT = trigger settings
;01 = samus touches the PLM
;02 = samus collects an item 
;03 = samus has collected an ammo type

;notes:
;when using 02, item, then the item is determined by the PLM x co-ordinate
;the x co-ordinate represents the item bitmask.. Index
;so if the PLM is at x co-ordinate 16, that means the 16th item bit ($8000)

;when using ammo type, the x co-ordinate represents which ammo type
;0 = missiles
;1 = super missiles
;2 = power bombs

org !Bank84Freespace
DW PLMinit,PLMinst

PLMinst:
DW $86B4

PLMinit:
TYX : JSL check : BCS +
LDA $1DC7,y : XBA : AND #$00FF : ASL : TAX  : LDA conditions,x : STA $1CD7,y
JMP (condition_setups,x)
CMP #ammo : BNE +
TYX : JSL $848290
+
CMP #item : BNE +

+
RTS

conditions:
DW position,item,ammo

condition_setups:
DW position_setup,item_setup,ammo_setup

position_setup:
LDX $1C87,y
LDA #$3045 : JSR $82B4
RTS

item_setup:
TYX : JSL $848290 : ASL : TAX : LDA $81839F,x : STA $1E17,y
RTS

ammo_setup:
TYX : JSL $848290 : ASL : TAX : LDA Ammos,x : STA $1E17,y
RTS
Ammos:
DW $09C8,$09CC,$09D0

position:
LDA $1D77,x : BEQ + ; check if triggered
BRA Trigger
+
RTS

item:
LDA $09A4 : BIT $1E17,x : BEQ + ; check if collected item
BRA Trigger
+
RTS

ammo:
LDA $1E17,x : STA $10 ; check if has more than 0 max of the ammo type
LDA ($10) : BEQ +
BRA Trigger
+
RTS

Trigger:
LDA #$0001 : STA $7EDE1C,x : LDA #$DFA9 : STA $1D27,x ;write neutral air level data
STZ $1C37,x;delete plm
JSL Activate
RTS

org $828B4F
JSR checkLocking
NOP #2

org $82F710;if dialogue, store 0 to the inputs
checkLocking:
LDA !DialogueFlag : BIT #$0001 : BEQ +
STZ $8F : STZ $8B
+
RTS

;--------ANY BANK 1--------
;---ICON gfx storage-------
;Add more .BIN files with the icons for characters here, in the same way as the examples below
;to add one, copy one of the already included .Bin files, edit it in your favorite gfx editor, and add it.
;make sure to add the labels, and use those in the dialogue definitions
org !BankAny1Freespace
Samus:
INCBIN samus.bin
Pirate:
INCBIN Pirate.bin